% Read WIN data file
%
clear all; close all;

% ---------------------------
% Parameter Initialize
%
filepath = 'SampleWIN.win';
ADres    = 3.22465*10^-6;                     % Volt/bit for LS-7000XT <- See manual p.52
% ADres    = 40/2^24;                           % Volt/bit
FORMAT   = {'bit4','bit8','bit16','bit24','bit32'};
BLOCK    = 0;
ROOP     = 1;

% ---------------------------
% Open WIN file
%
[fid,message] = fopen(filepath,'r','b');
if fid == -1, error(message); end

% ---------------------------
% Read WIN file
%
while 1                                                             % Ō܂Ńf[^BĂłfeof(fid)1ɂȂ炸ɂx[vɓĂ܂̂ŁABLOCK܂œǂ܂Ă画f鎖ɂ
    BLOCK    = BLOCK + fread(fid,1,'ubit32');                       % Block Size / 4Byte
    if feof(fid), break, end
    HEADtime = (reshape(fread(fid,12,'ubit4'),2,6)'*[10;1])';       % Channel Header / 4Byte
    if ROOP == 1
        if HEADtime(1) < 50
        	HEADtime(1) = HEADtime(1)+2000;
        else
        	HEADtime(1) = HEADtime(1)+1900;
        end
        STARTTIME    = datenum(HEADtime);
    end
    chn      = 1;
    while ftell(fid) < BLOCK
        HEADch   = sprintf('%04X',fread(fid,1,'ubit16'));           % Channel ID / 2Byte
        HEADsize = fread(fid,1,'ubit4');                            % Sample Size / 0.5Byte
        HEADrate = fread(fid,1,'ubit12');                           % Sampling Rate / 1.5Byte
        DATAtop  = fread(fid,1,'bit32');                            % First value of Sample Data
        DATAdiff = fread(fid,HEADrate-1,FORMAT{HEADsize+1});        % Differencial values of 1s Sample Data
        if HEADsize == 0 && rem(HEADrate,2) == 0                    % 4 epmty bits are added if sample size is 0.5Byte and sampling rate is even value.
            fread(fid,1,'bit4');
        end
%         fprintf('ChID:%04x, StartTime:%02d/%02d/%02d %02d:%02d:%02d, SampleSize:%-5s, SamplingRate:%4d, BLOCK:%4d, ftell(fid):%5d\n',HEADch,HEADtime,char(FORMAT(HEADsize+1)),HEADrate,BLOCK,ftell(fid));
        if ROOP == 1
            lpts         = 0;
            ChTbl{chn}   = HEADch;
            SmpRate(chn) = HEADrate;
        else
            chn          = find(strcmp(ChTbl,HEADch),1);
            lpts         = size(DATA{chn},1);
        end
        DATA{chn}(lpts+1:lpts+HEADrate,1) = cumsum([DATAtop;DATAdiff])*ADres;   % Cumulative Sum of Sample Data
        chn      = chn + 1;
    end
    ROOP = ROOP + 1;
end
fclose(fid);

% ---------------------------
% Plot
%
figure(1);
subplot(3,1,1),plot((0:size(DATA{1},1)-1)/SmpRate(1),DATA{1}); grid on;
title(datestr(STARTTIME,'yyyy/mm/dd HH:MM:SS'));
xlabel('TIME/Sec'); ylabel('Amplitude/V'); legend(ChTbl{1});
subplot(3,1,2),plot((0:size(DATA{2},1)-1)/SmpRate(2),DATA{2}); grid on;
xlabel('TIME/Sec'); ylabel('Amplitude/V'); legend(ChTbl{2});
subplot(3,1,3),plot((0:size(DATA{3},1)-1)/SmpRate(3),DATA{3}); grid on;
xlabel('TIME/Sec'); ylabel('Amplitude/V'); legend(ChTbl{3});

% ---------------------------
% Clear useless variables
%
clear ADres BLOCK DATAtop DATAdiff FORMAT HEADch HEADrate HEADsize HEADtime ROOP ans chn fid lpts message
